VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cNodeType"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private mType               As String

Private mImageKey           As String
Private mExpandedImageKey   As String
Private mCaptionColour      As Long
Private mCaptionBold        As Boolean
Private mCaptionItalic      As Boolean
Private mDragDropBehaviour  As enumDragScope
Private mSortMethod         As enumNodeSortMethod
Private mSortPriority       As Integer
'Private mDefaultChildType   As String
Private mValidChildTypes    As String

'User Interactivity
Private mUserCanEdit                As Boolean
Private mUserCanDelete              As Boolean
Private mUserCanAddSiblings         As Boolean
Private mUserCanAddChildren         As Boolean

Private mMasterType         As cNodeType

Event NodeTypeChanged(RecalcNeeded As Boolean, NodeKey As String, SortNeeded As Boolean)
Friend Property Get MasterType() As cNodeType
    Set MasterType = mMasterType
End Property
Friend Property Set MasterType(pType As cNodeType)
    Set mMasterType = pType
End Property
Public Property Let UserCanEdit(pValue As Boolean)
    mUserCanEdit = pValue
End Property
Public Property Get UserCanEdit() As Boolean
    UserCanEdit = mUserCanEdit
End Property
Public Property Let UserCanDelete(pValue As Boolean)
    mUserCanDelete = pValue
End Property
Public Property Get UserCanDelete() As Boolean
    UserCanDelete = mUserCanDelete
End Property
Public Property Let UserCanAddSiblings(pValue As Boolean)
    mUserCanAddSiblings = pValue
End Property
Public Property Get UserCanAddSiblings() As Boolean
    UserCanAddSiblings = mUserCanAddSiblings
End Property
Public Property Let UserCanAddChildren(pValue As Boolean)
    mUserCanAddChildren = pValue
End Property
Public Property Get UserCanAddChildren() As Boolean
    UserCanAddChildren = mUserCanAddChildren
End Property
Public Property Get CaptionColour() As Long
    CaptionColour = mCaptionColour
End Property
Public Property Let CaptionBold(pValue As Boolean)
    If Not (mCaptionBold = pValue) Then
        mCaptionBold = pValue
        If Initialised Then mMasterType.NotifyNodeTypeChange True, vbNullString, False
    End If
End Property
Public Property Get CaptionBold() As Boolean
    CaptionBold = mCaptionBold
End Property
Public Property Let CaptionItalic(pValue As Boolean)
    If Not (mCaptionItalic = pValue) Then
        mCaptionItalic = pValue
        If Initialised Then mMasterType.NotifyNodeTypeChange True, vbNullString, False
    End If
End Property
Public Property Get CaptionItalic() As Boolean
    CaptionItalic = mCaptionItalic
End Property
Public Property Let CaptionColour(pColour As Long)
    mCaptionColour = pColour
    If Initialised Then mMasterType.NotifyNodeTypeChange False, vbNullString, False
End Property
Public Property Get DragDropBehaviour() As enumDragScope
    DragDropBehaviour = mDragDropBehaviour
End Property
Public Property Let DragDropBehaviour(pBehaviour As enumDragScope)
    mDragDropBehaviour = pBehaviour
End Property
Public Property Let ValidChildTypes(pPipeDelimitedList As String)
   If Not Left$(pPipeDelimitedList, 1) = "|" Then pPipeDelimitedList = "|" & pPipeDelimitedList
   If Not Right$(pPipeDelimitedList, 1) = "|" Then pPipeDelimitedList = pPipeDelimitedList & "|"
   mValidChildTypes = pPipeDelimitedList
End Property
Public Property Get ValidChildTypes() As String
    ValidChildTypes = mValidChildTypes
End Property
Public Function IsValidChildType(pType As String) As Boolean
   If mValidChildTypes = "*" Then
      IsValidChildType = True
   Else
      IsValidChildType = InStr(1, mValidChildTypes, "|" & pType & "|")
   End If
End Function
Friend Property Get DefaultChildType() As String
Dim s() As String
   If Len(mValidChildTypes) = 0 Then
      Exit Property
   ElseIf mValidChildTypes = "*" Then 'All types are allowed (the default), as indicated by the * that was assigned in class_initialise
      DefaultChildType = mType 'since we don't have a list of valid child types, we'll make the default the same type as the parent
   Else 'otherwise, the default child type is the first listed type in mValidChildTypes
      s() = Split(mValidChildTypes, "|")
      DefaultChildType = s(1)
   End If
End Property
Public Property Let SortPriority(pPriority As Integer)
    mSortPriority = pPriority
End Property
Public Property Get SortPriority() As Integer
    SortPriority = mSortPriority
End Property
Public Property Get SortMethod() As enumNodeSortMethod
    SortMethod = mSortMethod
End Property
Public Property Let SortMethod(pSortMethod As enumNodeSortMethod)
    If Not (mSortMethod = pSortMethod) Then
        mSortMethod = pSortMethod
        If Initialised And mSortMethod > eNoSort Then
            mMasterType.NotifyNodeTypeChange False, vbNullString, True
        End If
    End If
End Property
Friend Property Let Name(pName As String)
    mType = pName
End Property
Public Property Get Name() As String ' this is the default property
Attribute Name.VB_UserMemId = 0
    Name = mType
End Property
Public Property Get ImageKey() As String
    ImageKey = mImageKey
End Property
Friend Property Let ImageKey(pKey As String)
    mImageKey = pKey
End Property
Friend Property Let ExpandedImageKey(pKey As String)
    mExpandedImageKey = pKey
End Property
Friend Property Get ExpandedImageKey() As String
    ExpandedImageKey = mExpandedImageKey
End Property
Friend Sub NotifyNodeTypeChange(pRecalcNeeded As Boolean, NodeKey As String, SortNeeded As Boolean)
    'only the Master Type, which is referenced by all other types, will ever raise this event
    RaiseEvent NodeTypeChanged(pRecalcNeeded, NodeKey, SortNeeded)
End Sub
Private Function Initialised() As Boolean
    Initialised = Not (mMasterType Is Nothing)
End Function
Private Sub Class_Initialize()
    mCaptionColour = vbWindowText
    mCaptionBold = False
    mCaptionItalic = False
    mUserCanEdit = False
    mUserCanDelete = False
    mUserCanAddSiblings = False
    mUserCanAddChildren = False
    mSortMethod = eNoSort
    mValidChildTypes = "*"
End Sub
