VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cNodeTypes"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private WithEvents mMasterType As cNodeType 'conduit through which events are raised by Node Types
Attribute mMasterType.VB_VarHelpID = -1

Private mNodeTypes As Collection
Event NodeTypeChanged(RecalcNeeded As Boolean, NodeKey As String, SortNeeded As Boolean)
Private Sub mMasterType_NodeTypeChanged(RecalcNeeded As Boolean, NodeKey As String, SortNeeded As Boolean)
    RaiseEvent NodeTypeChanged(RecalcNeeded, NodeKey, SortNeeded)
End Sub
Public Sub Add(pType As String, _
                pImageKey As String, _
                Optional pExpandedImageKey As String, _
                Optional pCaptionColour As Long = vbWindowText, _
                Optional pCaptionBold As Boolean, _
                Optional pCaptionItalic As Boolean, _
                Optional pSortMethod As enumNodeSortMethod = eNoSort, _
                Optional pSortPriority As Integer = 0, _
                Optional pDragDropBehaviour As enumDragScope = eUnsupported, _
                Optional pUserInteractivity As enumUserInteractivty = eAllowNone)
                
Dim NewType As cNodeType

    Set NewType = New cNodeType
    
    With NewType
        .Name = pType
        .ImageKey = pImageKey
        If Len(pExpandedImageKey) > 0 Then
            .ExpandedImageKey = pExpandedImageKey
        Else
            .ExpandedImageKey = pImageKey
        End If
        .DragDropBehaviour = pDragDropBehaviour
        .SortMethod = pSortMethod
        .SortPriority = pSortPriority
        .CaptionColour = pCaptionColour
        .CaptionBold = pCaptionBold
        .CaptionItalic = pCaptionItalic
        .UserCanDelete = pUserInteractivity And eAllowDeletes
        .UserCanEdit = pUserInteractivity And eAllowEdits
        .UserCanAddChildren = pUserInteractivity And eAllowChildren
        .UserCanAddSiblings = pUserInteractivity And eAllowSiblings
        
        'if a node type has a reference to the master type then it triggers recalc events
        'when some of the above properties are changed. Therefore, we set the reference last
        'to avoid this during initialisation of a new Node Type
        Set .MasterType = mMasterType
        
        mNodeTypes.Add NewType, pType
        
    End With
End Sub
Friend Sub Remove(VarIndex As Variant)
   mNodeTypes.Remove VarIndex
End Sub
Public Function Item(VarIndex As Variant) As cNodeType
Attribute Item.VB_UserMemId = 0
   Set Item = mNodeTypes.Item(VarIndex)
End Function
Friend Property Get Count() As Long
   Count = mNodeTypes.Count
End Property
Public Sub Clear()
   Class_Initialize
End Sub
Function NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
   Set NewEnum = mNodeTypes.[_NewEnum]
End Function
Private Sub Class_Initialize()
   Set mNodeTypes = New Collection
   Set mMasterType = New cNodeType
   Add ROOT_TYPE, "NO_DROP", "NO_DROP", , , , eNoSort
   mNodeTypes(ROOT_TYPE).UserCanAddChildren = True
End Sub
Private Sub Class_Terminate()
   On Error Resume Next
   Set mNodeTypes = Nothing
   Set mMasterType = Nothing
End Sub
