VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cTreeAppearance"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private mNodeFont                   As StdFont
Private mBackColour                 As Long 'client area colour (if no picture used)
Private mBackImageSetting           As enumBackImageSettings
Private mBackImageOpacity           As Double
Private mSelectedColour             As Long 'the 'colour to highlight the selected node
Private mStateIconColour            As Long
Private mBackImage                  As cCairoSurface

Event Changed(RecalcCaptionWidths As Boolean)

Private Declare Function GetSysColor Lib "user32" (ByVal nIndex As Long) As Long
Const COLOR_HOTLIGHT As Long = 26
Const COLOR_HIGHLIGHT As Long = 13
Public Sub SetFont(pName As String, pSize As Single)
   If pSize < 6 Then pSize = 6
   With mNodeFont
      .Size = pSize
      .Name = pName
   End With
   RaiseEvent Changed(True)
End Sub
Public Property Get FontName() As String
   FontName = mNodeFont.Name
End Property
Public Property Get FontSize() As Currency
   FontSize = mNodeFont.Size
End Property
Public Property Let FontSize(pSize As Currency)
   If pSize < 6 Then pSize = 6
   mNodeFont.Size = pSize
   RaiseEvent Changed(True)
End Property
Public Property Set BackImage(pSurface As cCairoSurface)
   Set mBackImage = pSurface
   RaiseEvent Changed(False)
End Property
Public Property Get BackImage() As cCairoSurface
   Set BackImage = mBackImage
End Property
Public Property Let BackColour(pColour As Long)
   mBackColour = pColour
   RaiseEvent Changed(False)
End Property
Public Property Get BackColour() As Long
    BackColour = mBackColour
End Property
Public Property Let BackImageSetting(pSetting As enumBackImageSettings)
   mBackImageSetting = pSetting
   RaiseEvent Changed(False)
End Property
Public Property Get BackImageSetting() As enumBackImageSettings
    BackImageSetting = mBackImageSetting
End Property
Public Property Let BackImageOpacity(pValue As Double)
   mBackImageOpacity = pValue
   RaiseEvent Changed(False)
End Property
Friend Property Get BackImageOpacity() As Double
   BackImageOpacity = mBackImageOpacity
End Property
'NODE COLOURING
Public Property Let SelectedColour(pColour As Long)
   mSelectedColour = pColour
   RaiseEvent Changed(False)
End Property
Public Property Get SelectedColour() As Long
    SelectedColour = mSelectedColour
End Property
'STATE ICON STUFF
Public Property Let StateIconColour(pColour As Long)
   mStateIconColour = pColour
   CreateStateIcons
   RaiseEvent Changed(False)
End Property
Private Sub CreateStateIcons()
    CreateStateIcon "StateCollapsed"
    CreateStateIcon "StateExpanded"
End Sub
Private Sub CreateStateIcon(pStateImageKey As String)

   Cairo.ImageList.AddSurface pStateImageKey, Cairo.CreateSurface(32, 32)

   With Cairo.ImageList(pStateImageKey).CreateContext
      .SetSourceColor mStateIconColour
      .SetLineWidth 3
      .Save
         .TranslateDrawings 16, 16
         If pStateImageKey = "StateExpanded" Then
            .RotateDrawingsDeg 90
            .TranslateDrawings 5, 5
         End If
         
         .MoveTo -10, -10
         .RelLineTo 10, 10
         .RelLineTo -10, 10
         
         .Stroke True
      .Restore
   End With

End Sub

Private Sub Class_Initialize()

   Set mNodeFont = New StdFont
   mNodeFont.Name = "Tahoma"
   mNodeFont.Size = 10

   mSelectedColour = GetSysColor(COLOR_HIGHLIGHT)
   Set mBackImage = Cairo.CreateSurface(10, 10)
   mStateIconColour = vbBlack
   mBackColour = vbWindowBackground
   mBackImageSetting = eImageNone
   mBackImageOpacity = 0.02
    
   CreateStateIcons
    
End Sub

