VERSION 5.00
Begin VB.UserControl ucVhTree 
   Appearance      =   0  'Flat
   BackColor       =   &H008080FF&
   ClientHeight    =   7905
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   5085
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   KeyPreview      =   -1  'True
   MousePointer    =   1  'Arrow
   ScaleHeight     =   527
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   339
   Begin VB.PictureBox picHScroll 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   255
      Left            =   1320
      ScaleHeight     =   17
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   161
      TabIndex        =   3
      TabStop         =   0   'False
      Top             =   7320
      Width           =   2415
   End
   Begin VB.PictureBox picVScroll 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   1575
      Left            =   4560
      ScaleHeight     =   105
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   17
      TabIndex        =   2
      TabStop         =   0   'False
      Top             =   240
      Width           =   255
   End
   Begin VB.TextBox txtNodeEdit 
      Appearance      =   0  'Flat
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   0  'None
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   1920
      TabIndex        =   0
      Text            =   "Text1"
      Top             =   6930
      Visible         =   0   'False
      Width           =   1095
   End
   Begin VB.PictureBox picCanvas 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   6735
      Left            =   0
      ScaleHeight     =   449
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   289
      TabIndex        =   1
      Top             =   0
      Width           =   4335
   End
End
Attribute VB_Name = "ucVhTree"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private WithEvents SCMouseTrack     As cSubClass
Attribute SCMouseTrack.VB_VarHelpID = -1
Private WithEvents mViewport        As cTreeViewport
Attribute mViewport.VB_VarHelpID = -1
Private WithEvents mExposedNodes    As cExposedNodes
Attribute mExposedNodes.VB_VarHelpID = -1
Private WithEvents mAllNodes        As cVhNodes
Attribute mAllNodes.VB_VarHelpID = -1
Private WithEvents mAppearance      As cTreeAppearance
Attribute mAppearance.VB_VarHelpID = -1
Private WithEvents cDragTimer       As cTimer
Attribute cDragTimer.VB_VarHelpID = -1
Private WithEvents mVScroll         As cScrollbar
Attribute mVScroll.VB_VarHelpID = -1
Private WithEvents mHScroll         As cScrollbar
Attribute mHScroll.VB_VarHelpID = -1

Private RenderCC                    As cCairoContext
Private mBackgroundSrf              As cCairoSurface
Private mMouseOverIndex             As Long

Private mSelectedItemIndex          As Long
Private mInvalidNodeChars           As String

Private mIconSize                   As Long
Private mCaptionHeight              As Double
Private mIconOffsetY                As Double
Private mCaptionOffsetY             As Double
Private mNodeHeight                 As Long 'total vertical space used by a node
Private mEditingNode                As Boolean
Private mMaxNodeWidth               As Long
Private mDragOp                     As typDragOperation
Private mHandPointer                As IPictureDisp 'our IDC_HAND mouse pointer, which we create

Event ExternalDragOver(Source As Control, X As Single, Y As Single, TargetNodeKey As String, State As Integer)
Event ExternalDragDrop(Source As Control, X As Single, Y As Single, TargetNodeKey As String)
Event SelectionChanged()
Event UserRequestDelete(ShiftDown As Boolean, RefuseRequest As Boolean)
Event UserRequestNewNode(Key As String, ParentKey As String, Caption As String, TypeName As String, RequestType As enumNodeRequestType)
Event AfterLabelEdit(OldCaption As String, NewCaption As String, Cancel As Boolean, Succeeded As Boolean)
Event KeyDown(KeyCode As Integer, CtrlDown As Boolean, ShiftDown As Boolean, AltDown As Boolean)
Event MouseLeave()
Event NodeAdded(Caption As String, NodeType As String)

Private Type POINTAPI
   X As Long
   Y As Long
End Type

Private Type typDragOperation 'cache of drag-related variables
   MouseDownXY       As POINTAPI 'mouse co-ords at drag start
   MouseXY           As POINTAPI 'mouse co-ords during drag
   SourceNode        As cVhNode   'the node being dragged
   DragOverIndex     As Long     'Viewport index of node being dragged over
   IsInternal        As Boolean 'true when a node is dragged. False when another control is dragged over the tree
   TargetNodeKey     As String   'Key of node being dragged over
   HoverZoom         As Single   'Zoom size of expanding node effect
   ExpandHoverTime   As Long
   ExternalIcon      As IPictureDisp 'used to cache the drag icon associated with an external control
   PrevousIconKey    As String 'used to stop the same drag icon from being created over-and-over
End Type

Private Type RECT
   Left As Long
   Top As Long
   Right As Long
   Bottom As Long
End Type

Private Declare Function PtInRect Lib "user32.dll" (lpRect As RECT, ByVal X As Long, ByVal Y As Long) As Long

Private Type tagTRACKMOUSEEVENT
   cbSize As Long
   dwFlags As Long
   hwndTrack As Long
   dwHoverTime As Long
End Type
Private Declare Function TrackMouseEvent Lib "user32" (TME As tagTRACKMOUSEEVENT) As Long

Private mInCtrl As Boolean, mHasFocus As Boolean
Public Property Get EditTextBox() As TextBox
   Set EditTextBox = txtNodeEdit
End Property
Private Sub picCanvas_DblClick()
   If mMouseOverIndex > 0 Then NodeDblClickHandler mViewport.Item(mMouseOverIndex)
End Sub
Private Sub picHScroll_GotFocus()
   picCanvas.SetFocus
End Sub
Private Sub picVScroll_GotFocus()
   picCanvas.SetFocus
End Sub
Private Sub SCMouseTrack_WindowProc(Result As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lparam As Long)
Const WM_MOUSEWHEEL& = &H20A&
Const WM_MOUSEMOVE& = &H200&
Const WM_KILLFOCUS& = &H8
Const TME_LEAVE& = &H2&
Const WM_MOUSELEAVE& = &H2A3&
Dim TME As tagTRACKMOUSEEVENT
Dim Rotation As Long

   On Error GoTo 1

    Select Case Msg
        Case WM_MOUSELEAVE, WM_KILLFOCUS
            mInCtrl = False
            mMouseOverIndex = 0
            mDragOp.DragOverIndex = 0
            Refresh
            RaiseEvent MouseLeave
    
        Case WM_MOUSEMOVE
            If Not mInCtrl Then
                mInCtrl = True
                TME.cbSize = Len(TME)
                TME.dwFlags = TME_LEAVE
                TME.dwHoverTime = 1000
                TME.hwndTrack = picCanvas.hWnd
                TrackMouseEvent TME
            End If
        Case WM_MOUSEWHEEL
            If mInCtrl Then
                Rotation = wParam \ 65536
                Scroll -Rotation / 120
            End If
    End Select

1: Result = SCMouseTrack.CallWindowProc(Msg, wParam, lparam)
End Sub
Private Sub cDragTimer_Timer()
Dim AutoExpand As Boolean, AutoScrollUp As Boolean, AutoScrollDown As Boolean

   AutoExpand = mDragOp.HoverZoom >= 0
   AutoScrollUp = (mDragOp.MouseXY.Y < mNodeHeight) And (mViewport.Position > 1)
   AutoScrollDown = (mDragOp.MouseXY.Y > picCanvas.Height - mNodeHeight) And (mViewport.Position < mViewport.MaxPosition)
   
   cDragTimer.Interval = 100
    
   If AutoScrollUp Then
      mDragOp.HoverZoom = -1
      mViewport.Shift -1
   ElseIf AutoScrollDown Then
      mDragOp.HoverZoom = -1
      mViewport.Shift 1
   Else
      If AutoExpand Then
         mDragOp.HoverZoom = mDragOp.HoverZoom + 0.4
         If mDragOp.HoverZoom > 2 Then
            mDragOp.HoverZoom = -1
            cDragTimer.Enabled = False
            NodeDblClickHandler Nodes(mViewport.KeyFromViewportIndex(mDragOp.DragOverIndex)), True
         Else
            Refresh
         End If
      End If
   End If
    
End Sub
Private Sub mAllNodes_NodeAdded(NewNode As cVhNode)
   CalcCaptionWidths NewNode.Key
End Sub
Private Sub mAllNodes_NodeCaptionChanged(NodeKey As String)
   CalcCaptionWidths NodeKey
End Sub
Private Sub mAllNodes_NodeCollapsed(NodeKey As String, CascadeCollapse As Boolean)
   InitClientArea
End Sub
Private Sub mAllNodes_NodeExpanded(NodeKey As String, CascadeExpansion As Boolean)
   InitClientArea
End Sub
Private Sub mAllNodes_NodeTypeChanged(RecalcNeeded As Boolean, NodeKey As String)
   If RecalcNeeded Then
      If Len(NodeKey) > 0 Then
         mAllNodes_NodeAdded mAllNodes(NodeKey)
      Else
         CalcCaptionWidths
      End If
   End If
   Refresh
End Sub
'EVENT RAISED BY APPEARANCE CLASS
Private Sub mAppearance_Changed(RecalcCaptionWidths As Boolean)
   UserControl.BackColor = mAppearance.BackColour
   mVScroll.SetColours mAppearance.BackColour, vbWhite, vbBlack
   mHScroll.SetColours mAppearance.BackColour, vbWhite, vbBlack
   CreateBackgroundBuffer
   If RecalcCaptionWidths Then
      CalcCaptionWidths
      InitClientArea
   End If
   Refresh
End Sub
'EVENTS RAISED BY EXPOSED NODES CLASS
Private Sub mExposedNodes_CompletelyRebuilt()
   mViewport.Refresh
End Sub
'EVENTS RAISED BY VIEWPORT
Private Sub mViewport_SelectionChanged(newPosition As Long)
    mSelectedItemIndex = newPosition
    Refresh
    RaiseEvent SelectionChanged
End Sub
Private Sub mViewport_ViewportChanged()
    InitClientArea
    Refresh
End Sub
Private Sub picCanvas_Paint()
   If Ambient.UserMode Then RenderCC.Surface.DrawToDC picCanvas.hDC
End Sub
Private Sub CreateBackgroundBuffer()
Dim X As Double, Y As Double, w As Double, H As Double

   Set mBackgroundSrf = Cairo.CreateSurface(UserControl.ScaleWidth, UserControl.ScaleHeight)
   With mBackgroundSrf.CreateContext
      .SetSourceColor mAppearance.BackColour
      .Paint
      Select Case mAppearance.BackImageSetting
         Case eImageNone
         Case eImageTiled
            w = mAppearance.BackImage.Width
            H = mAppearance.BackImage.Height
            For X = 0 To mBackgroundSrf.Width Step w
               For Y = 0 To mBackgroundSrf.Height Step H
                  .RenderSurfaceContent mAppearance.BackImage, X, Y, w, H, CAIRO_FILTER_FAST, mAppearance.BackImageOpacity 'fast for vee-hive only
               Next Y
            Next X
         Case eImageStretched
            .RenderSurfaceContent mAppearance.BackImage, 0, 0, mBackgroundSrf.Width, mBackgroundSrf.Height, , mAppearance.BackImageOpacity
         Case eImageAsIs
            .RenderSurfaceContent mAppearance.BackImage, 0, 0, , , , mAppearance.BackImageOpacity
      End Select
   End With
End Sub
Private Sub Draw()
Dim i As Long, thisNode As cVhNode, NodeItemXPos As Double, NodeItemYPos As Double

   mSelectedItemIndex = 0
   With RenderCC
      .RenderSurfaceContent mBackgroundSrf, 0, 0, , , CAIRO_FILTER_FAST

      For i = 1 To mViewport.Capacity
         If i <= mViewport.VisibleItemCount Then
            'Get our node
            Set thisNode = mViewport.Item(i)
            
            'work out where to start drawing from
            NodeItemXPos = ((thisNode.Tier - 1) * mIconSize) - mHScroll.Value
            NodeItemYPos = mNodeHeight * (i - 1)
            
            If thisNode.Key = Nodes.SelectedNode.Key Then
               DrawHighlight RenderCC, 1, NodeItemYPos, RenderCC.Surface.Width - 2, mNodeHeight, True, i = mDragOp.DragOverIndex
               mSelectedItemIndex = i
            ElseIf i = mMouseOverIndex Then
               DrawHighlight RenderCC, 1, NodeItemYPos, RenderCC.Surface.Width - 2, mNodeHeight
            ElseIf i = mDragOp.DragOverIndex Then
               DrawHighlight RenderCC, 1, NodeItemYPos, RenderCC.Surface.Width - 2, mNodeHeight, , True
            End If
            
            'draw the state icon
            If thisNode.Expanded Then
               .RenderSurfaceContent "StateExpanded", NodeItemXPos + mIconSize * 0.25, NodeItemYPos + mNodeHeight * 0.2, mNodeHeight * 0.6, mNodeHeight * 0.6
            Else
               If thisNode.Children.Count > 0 Then
                  .RenderSurfaceContent "StateCollapsed", NodeItemXPos + mIconSize * 0.25, NodeItemYPos + mNodeHeight * 0.2, mNodeHeight * 0.6, mNodeHeight * 0.6
               End If
            End If
            
            'then the node icon
            NodeItemXPos = NodeItemXPos + mIconSize
            If i = mDragOp.DragOverIndex And mDragOp.HoverZoom > 0 Then
               .RenderSurfaceContent thisNode.CurrentImageKey, NodeItemXPos - mDragOp.HoverZoom, NodeItemYPos + mIconOffsetY - mDragOp.HoverZoom, mIconSize + mDragOp.HoverZoom * 2, mIconSize + mDragOp.HoverZoom * 2
            Else
               .RenderSurfaceContent thisNode.CurrentImageKey, NodeItemXPos, NodeItemYPos + mIconOffsetY, mIconSize, mIconSize
            End If

            'and, finally, the label
            NodeItemXPos = NodeItemXPos + mIconSize + 4
            .SelectFont mAppearance.FontName, mAppearance.FontSize, thisNode.CaptionColour, thisNode.NodeType.CaptionBold, thisNode.NodeType.CaptionItalic
            
            If Not (mEditingNode And thisNode.Key = Nodes.SelectedNode.Key) Then
               .TextOut NodeItemXPos + 2, NodeItemYPos + mCaptionOffsetY, thisNode.Caption, False
            End If
         
         End If
      Next i
   
      If mEditingNode Then
         .SetLineWidth 1
         .SetSourceColor vbBlack
         .SelectFont mAppearance.FontName, mAppearance.FontSize, , SelectedItem.NodeType.CaptionBold, SelectedItem.NodeType.CaptionItalic
         .Rectangle txtNodeEdit.Left - 2, CDbl(txtNodeEdit.Top) - 2, .GetTextExtents(txtNodeEdit.Text & "W") + 4, mNodeHeight, True
         .Stroke True
         .SetSourceColor txtNodeEdit.BackColor
         .Fill
      End If
   
   End With
   picCanvas_Paint

End Sub
Private Sub DrawHighlight(ByVal CC As cCairoContext, ByVal X As Long, ByVal Y As Long, ByVal DX As Long, ByVal DY As Long, Optional IsSelectedNode As Boolean, Optional IsDragOverNode As Boolean)
Dim lColour As Long
   If mEditingNode Then Exit Sub
   If IsDragOverNode Or mHasFocus Then lColour = mAppearance.SelectedColour Else lColour = vbButtonShadow
   With CC
      .SetLineWidth 0.5
      .Rectangle X, Y, DX, DY, IsSelectedNode And mHasFocus
      .SetSourceColor lColour, IIf(IsSelectedNode, 0.3, 0.15)
      .Fill IsSelectedNode And mHasFocus
      If Not IsSelectedNode Then Exit Sub
      .SetSourceColor lColour, , 0.5
      .Stroke
   End With
End Sub
'===============================================================
'PUBLIC
'===============================================================
Public Sub Refresh()
   Draw
End Sub

Public Sub Scroll(pAmount As Long)
   mViewport.Shift pAmount
End Sub
Public Property Let Suspended(pValue As Boolean)
   mAllNodes.Suspended = pValue
   If Not pValue Then
      CalcCaptionWidths
      mAllNodes.SortAll
      mExposedNodes.Rebuild
   End If
End Property
Public Property Get Suspended() As Boolean
   Suspended = mAllNodes.Suspended
End Property
Public Property Get Appearance() As cTreeAppearance
   Set Appearance = mAppearance
End Property
Public Property Let AnimationSpeed(pSpeed As Double)
'Any value less than or equal to 1 turns animation off
'Any value greater than 1 effects accelerated animation
   If pSpeed <= 1 Then pSpeed = 0
   mViewport.AnimationSpeed = pSpeed
End Property
Public Property Get Nodes() As cVhNodes
   Set Nodes = mAllNodes
End Property
Public Property Get SelectedItem() As cVhNode
   Set SelectedItem = mAllNodes.SelectedNode
End Property
'===============================================================
'PRIVATE
'===============================================================
Private Sub ExpandNode(pKey As String, pCascade As Boolean)
   Nodes(pKey).Expand pCascade
End Sub
Private Sub CollapseNode(pKey As String, pCascade As Boolean)
   Nodes(pKey).Collapse pCascade
End Sub
Private Sub NodeDblClickHandler(pNode As cVhNode, Optional pExpansionsOnly As Boolean)
   If pNode Is Nothing Then Exit Sub
   
   If pNode.Expanded Then
      If Not pExpansionsOnly Then CollapseNode pNode.Key, False
   Else
      ExpandNode pNode.Key, False
   End If

End Sub
Private Function NewNodeRequest(pKey As String, pTypeName As String, pRequestType As enumNodeRequestType)
Dim thisNode As cVhNode, NewKey As String, NewNodeParentKey As String, NewNodeParent As cVhNode, NewNodeType As String, AllowNewNode As Boolean
Dim InitialCaption As String
    
    If pKey = vbNullString Then
        pKey = MASTER_ROOT
        pRequestType = eNewChild
        Set thisNode = mAllNodes.RootNode
    Else
        Set thisNode = mAllNodes(pKey)
    End If
    
    NewNodeType = pTypeName
    
    If pRequestType = eNewChild Then
        If thisNode.NodeType.UserCanAddChildren Then
            AllowNewNode = True
            Set NewNodeParent = thisNode
        End If
    Else
        If thisNode.NodeType.UserCanAddSiblings Then
            AllowNewNode = True
            Set NewNodeParent = thisNode.Parent
        End If
    End If
    
    If AllowNewNode Then
        InitialCaption = NewNodeParent.GetUniqueChildName("New " & NewNodeType, NewNodeType)
        If NewNodeParent.Key = MASTER_ROOT Then
            NewNodeParentKey = vbNullString
        Else
            NewNodeParentKey = NewNodeParent.Key
        End If
        RaiseEvent UserRequestNewNode(NewKey, NewNodeParentKey, InitialCaption, NewNodeType, pRequestType)
        NewNodeParent.Expanded = True
        mAllNodes.Add NewNodeParent.Key, NewKey, InitialCaption, NewNodeType
        mAllNodes.SelectNode NewKey
        StartLabelEdit InitialCaption, SelectedItem.Key
        RaiseEvent NodeAdded(NewKey, NewNodeType)
    End If
    
    NewNodeRequest = AllowNewNode
    
    RaiseEvent SelectionChanged
    
End Function
Private Sub picCanvas_KeyDown(KeyCode As Integer, Shift As Integer)
Dim UserCancel As Boolean

    If mEditingNode Then Exit Sub
    If mAllNodes.Count = 0 Then Exit Sub
    
    If mSelectedItemIndex = 0 Then mViewport.EnsureVisible SelectedItem.Key

    Select Case KeyCode
        Case vbKeyHome
            mViewport.Position = 1
            mViewport.SelectNodeByViewportPosition 1
        Case vbKeyEnd
            mViewport.Position = mExposedNodes.Count
            mViewport.SelectNodeByViewportPosition mViewport.VisibleItemCount
        Case vbKeyPageUp
            mViewport.Shift -Int(mViewport.ExactCapacity) + mSelectedItemIndex
            mViewport.SelectNodeByViewportPosition 1
        Case vbKeyPageDown
            mViewport.Shift mViewport.VisibleItemCount - (mViewport.VisibleItemCount - mSelectedItemIndex + 1)
            mViewport.SelectNodeByViewportPosition Int(mViewport.ExactCapacity)
        Case vbKeyF2
            If SelectedItem.NodeType.UserCanEdit Then
                'mViewport.EnsureVisible SelectedItem.Key
                StartLabelEdit SelectedItem.Caption, SelectedItem.Key
            End If
        Case vbKeyInsert
            If Shift Then
                If Len(SelectedItem.NodeType.DefaultChildType) > 0 Then
                    NewNodeRequest SelectedItem.Key, SelectedItem.NodeType.DefaultChildType, eNewChild
                Else
                    NewNodeRequest SelectedItem.Key, SelectedItem.NodeType, eNewChild
                End If
            Else
                NewNodeRequest SelectedItem.Key, SelectedItem.NodeType, eNewSibling
            End If
        Case vbKeyDelete
            If SelectedItem.NodeType.UserCanDelete Then
                RaiseEvent UserRequestDelete(Shift = 1, UserCancel)
                If Not UserCancel Then
                    Nodes.Remove SelectedItem.Key
                    Refresh
                End If
            Else
               Beep
            End If
        Case vbKeyMultiply
            If Shift Then
                CollapseNode SelectedItem.Key, True
            Else
                ExpandNode SelectedItem.Key, True
            End If
        Case vbKeyDown
            If mSelectedItemIndex + mViewport.Position <= mExposedNodes.Count Then
                If mSelectedItemIndex = Int(mViewport.ExactCapacity) Then mViewport.Shift 1
                mViewport.SelectNodeByViewportPosition mSelectedItemIndex + 1
            End If
        Case vbKeyUp
            If mSelectedItemIndex + mViewport.Position - 1 > 1 Then
                If mSelectedItemIndex = 1 Then mViewport.Shift -1
                mViewport.SelectNodeByViewportPosition mSelectedItemIndex - 1
            End If
        Case vbKeyRight
            If SelectedItem.Expanded And SelectedItem.Children.Count > 0 Then
                picCanvas_KeyDown vbKeyDown, 0
            Else
                ExpandNode SelectedItem.Key, False
            End If
        Case vbKeyLeft
            If SelectedItem.Expanded And SelectedItem.Children.Count > 0 Then
                mAllNodes(SelectedItem.Key).Collapse False
            Else
                If SelectedItem.Tier > 1 Then
                    Nodes.SelectNode SelectedItem.Parent.Key
                    mViewport.EnsureVisible Nodes.SelectedNode.Key
                End If
            End If
    End Select

    RaiseEvent KeyDown(KeyCode, Shift = 2, Shift = 1, Shift = 4)
    
End Sub
Private Sub picCanvas_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim OverStateIcon As Boolean, MouseDownIndex As Long
   
   MouseDownIndex = HitTest(X, Y, OverStateIcon)
   With mDragOp
      .MouseDownXY.X = X
      .MouseDownXY.Y = Y
      
      If MouseDownIndex = 0 Then
         Set .SourceNode = Nothing
      Else
         Set .SourceNode = mAllNodes(mViewport.KeyFromViewportIndex(MouseDownIndex))
      End If
      
      If OverStateIcon Then
         If Button = vbLeftButton Then NodeDblClickHandler .SourceNode
      Else
         If MouseDownIndex > 0 Then mViewport.SelectNodeByViewportPosition MouseDownIndex
         If mSelectedItemIndex > Int(mViewport.ExactCapacity) Then mViewport.Shift 1
      End If
   End With
End Sub
Private Sub picCanvas_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim MouseOverIndex As Integer, Behaviour As enumDragScope, bStartDrag As Boolean

    MouseOverIndex = HitTest(X, Y)
    cDragTimer.Enabled = False
    mDragOp.HoverZoom = -1
    
    If Button = vbLeftButton And Not mDragOp.SourceNode Is Nothing Then
        bStartDrag = (Abs(mDragOp.MouseDownXY.X - X) > 5) Or (Abs(mDragOp.MouseDownXY.Y - Y) > 5) 'mouse moved more than 5 pixels
        If bStartDrag Then
            Behaviour = Nodes(mDragOp.SourceNode.Key).DragDropBehaviour
            If (Behaviour And eInternalSource) Or (Behaviour And eExternalSource) Then
               InitDragIcons UserControl.Extender
               UserControl.Extender.Drag vbBeginDrag
            End If
        End If
    Else
        If MouseOverIndex <> mMouseOverIndex Then
            mMouseOverIndex = MouseOverIndex
            Refresh
        End If
        If MouseOverIndex > 0 Then
            picCanvas.MousePointer = vbCustom
            Set picCanvas.MouseIcon = mHandPointer
        Else
            picCanvas.MousePointer = vbArrow
        End If
        Set mDragOp.SourceNode = Nothing
    End If

End Sub
Private Function HitTest(ByVal pX As Single, ByVal pY As Single, Optional pStateIconHit_OUT As Boolean) As Long
Dim HitRow As Long, thisNode As cVhNode, StateIconRECT As RECT
    
   pX = pX + mHScroll.Value
   HitRow = 1 + (pY \ mNodeHeight)
    
   If HitRow <= mViewport.VisibleItemCount Then
      Set thisNode = mViewport.Item(HitRow)
      StateIconRECT.Left = NodeCaptionStartX(thisNode.Tier) - mIconSize * 2 - 4
      StateIconRECT.Top = (HitRow - 1) * mNodeHeight + mIconOffsetY
      StateIconRECT.Right = StateIconRECT.Left + mIconSize - 4
      StateIconRECT.Bottom = StateIconRECT.Top + mNodeHeight - mIconOffsetY * 2
      pStateIconHit_OUT = PtInRect(StateIconRECT, pX, pY)
   Else
      HitRow = 0
   End If
   HitTest = HitRow
End Function
Private Sub mVScroll_Change(NewValue As Double)
   CancelIfEditing
   mViewport.Position = NewValue
End Sub
Private Sub mVScroll_Scroll(ExactValue As Double)
   mVScroll_Change Round(ExactValue)
End Sub
Private Sub mHScroll_Change(NewValue As Double)
   CancelIfEditing
   Draw
End Sub
Private Sub mHScroll_Scroll(ExactValue As Double)
   mHScroll_Change Round(ExactValue)
End Sub
'===============================================================
'USER NODE EDITING
'===============================================================
Private Sub CancelIfEditing()
   txtNodeEdit.Visible = False
End Sub
Public Sub StartLabelEdit(pInitText As String, pNodeKey As String)
   mAllNodes.SelectNode pNodeKey
   mViewport.EnsureVisible pNodeKey
   InitEditBox pInitText
End Sub
Private Sub InitEditBox(pInitText As String)
Dim TargetWidth As Long, TargetLeft As Long, CurrentLeft As Double, HScrollAdj As Integer, NewHScrollValue As Long, i As Integer

   RenderCC.SelectFont mAppearance.FontName, mAppearance.FontSize, , SelectedItem.NodeType.CaptionBold, SelectedItem.NodeType.CaptionItalic
   TargetWidth = RenderCC.GetTextExtents(pInitText & "W")
   TargetLeft = NodeCaptionStartX(SelectedItem.Tier) + 2
   CurrentLeft = TargetLeft - mHScroll.Value
   
   If CurrentLeft < 0 Then
      HScrollAdj = TargetLeft - mHScroll.Value
      CurrentLeft = 0
   End If
    
   If CurrentLeft + TargetWidth > picCanvas.ScaleWidth Then
      HScrollAdj = HScrollAdj + CurrentLeft + TargetWidth - picCanvas.ScaleWidth
   End If
   
   If TargetWidth > picCanvas.ScaleWidth Then TargetWidth = picCanvas.ScaleWidth - 4
    
   NewHScrollValue = mHScroll.Value + HScrollAdj
   If NewHScrollValue > mHScroll.Max Then
      NewHScrollValue = mHScroll.Max
   ElseIf NewHScrollValue < 1 Then
      NewHScrollValue = 1
   End If
    
   If mHScroll.Value - NewHScrollValue <> 0 Then
      For i = mHScroll.Value To NewHScrollValue Step mHScroll.SmallChange * ((NewHScrollValue - mHScroll.Value) / Abs((NewHScrollValue - mHScroll.Value)))
         mHScroll.Value = i
      Next i
   End If
   mHScroll.Value = NewHScrollValue
   mEditingNode = True

   TargetLeft = TargetLeft - mHScroll.Value
   If TargetLeft < 0 Then TargetLeft = 0

   With txtNodeEdit
      .Font = mAppearance.FontName
      .FontSize = mAppearance.FontSize
      .FontBold = SelectedItem.NodeType.CaptionBold
      .FontItalic = SelectedItem.NodeType.CaptionItalic
      .Text = pInitText
      .Move TargetLeft, ((mSelectedItemIndex - 1) * mNodeHeight) + mCaptionOffsetY, TargetWidth, 8
      .SelStart = 0
      .SelLength = Len(.Text)
      .Enabled = True
      .Visible = True
      .SetFocus
   End With

   Refresh

End Sub
Private Sub txtNodeEdit_Change()
Dim TargetWidth As Long
    With txtNodeEdit
        TargetWidth = RenderCC.GetTextExtents(.Text & "W")
        If .Left + TargetWidth > (picCanvas.ScaleWidth - 4) Then
            TargetWidth = picCanvas.ScaleWidth - .Left - 4
        End If
        .Width = TargetWidth
    End With
    Refresh
End Sub
Private Sub txtNodeEdit_KeyPress(KeyAscii As Integer)
Dim s As String

    On Error GoTo ErrorHandler
    
    With txtNodeEdit
        Select Case KeyAscii
            Case vbKeyEscape
               mEditingNode = False
               s = SelectedItem.Caption
               RaiseEvent AfterLabelEdit(s, s, True, False)
                KeyAscii = 0
               .Enabled = False 'triggers the _validate event
            Case 13
               txtNodeEdit_Validate False
               KeyAscii = 0
               If Not mEditingNode Then .Enabled = False 'triggers the _validate event
            Case Else
                mInvalidNodeChars = "\/*|_"""
                s = Chr$(KeyAscii)
                If InStr(1, mInvalidNodeChars, s) Then
                    KeyAscii = 0
                    Beep
                End If
                Exit Sub
        End Select
    End With
        
    Exit Sub
    
ErrorHandler:
    MsgBox Err.Description, vbExclamation, "Denied!" ', , True
    mEditingNode = True
End Sub
Private Sub txtNodeEdit_Validate(Cancel As Boolean)
Dim OldCaption As String

   On Error GoTo ErrorHandler
   
   With txtNodeEdit
      If Not mEditingNode Then
         'User pressed esc key - do nothing
      ElseIf Len(.Text) = 0 Then
         Cancel = True
      Else
         OldCaption = SelectedItem.Caption
         RaiseEvent AfterLabelEdit(OldCaption, .Text, Cancel, False)
         If Not Cancel Then
            Cancel = Not Nodes(SelectedItem.Key).IsUniqueChild(SelectedItem.Parent, .Text, SelectedItem.NodeType)
            If Cancel Then
               MsgBox "Name must be unique among it's siblings", vbExclamation, "Invalid Caption", , True
            Else
               Suspended = True
               SelectedItem.Caption = .Text 'forces node re-measurement/sorting etc
               RaiseEvent AfterLabelEdit(OldCaption, .Text, False, True)
               Suspended = False
            End If
         End If
      .SetFocus
      End If
   End With
   mEditingNode = Cancel
   Exit Sub

ErrorHandler:
    MsgBox Err.Description, vbExclamation, "Denied!" ', , True
    Cancel = True: mEditingNode = True
End Sub
Private Sub txtNodeEdit_LostFocus()
   If Not mEditingNode Then
      txtNodeEdit.Visible = False
      txtNodeEdit.Enabled = False
      mViewport.EnsureVisible SelectedItem.Key
      Refresh
   End If
End Sub
Private Sub UserControl_GotFocus()
   picCanvas_GotFocus
End Sub
Private Sub UserControl_LostFocus()
   picCanvas_LostFocus
End Sub
Private Sub picCanvas_GotFocus()
   mHasFocus = True
   Refresh
End Sub
Private Sub picCanvas_LostFocus()
   mHasFocus = False
   Refresh
End Sub
Private Sub UserControl_Resize()
   If Not Ambient.UserMode Then Exit Sub
   InitClientArea
   CreateBackgroundBuffer
   Refresh
End Sub
Private Sub InitClientArea()
Dim NeedHScrollbar As Boolean, NeedVScrollbar As Boolean, NewLargeChange As Integer

    CalcMetrics
    
    mMaxNodeWidth = mExposedNodes.WidestNodeWidth + ((mIconSize * 2) + 4)
    
    NeedHScrollbar = (mMaxNodeWidth > UserControl.ScaleWidth)
    NeedVScrollbar = (mExposedNodes.Count > (UserControl.ScaleHeight \ mNodeHeight))
    
    If Not (NeedHScrollbar And NeedVScrollbar) Then
        If NeedHScrollbar Then
            NeedVScrollbar = (mExposedNodes.Count > ((UserControl.ScaleHeight - picHScroll.Height) \ mNodeHeight))
        ElseIf NeedVScrollbar Then
            NeedHScrollbar = (mMaxNodeWidth > (UserControl.ScaleWidth - picVScroll.Width))
        End If
    End If
    
    With UserControl
        If NeedVScrollbar Then
            picVScroll.Move .ScaleWidth - picVScroll.Width, 0, picVScroll.Width, .ScaleHeight - IIf(NeedHScrollbar, picHScroll.Height, 0)
        End If
        If NeedHScrollbar Then
            picHScroll.Move 0, .ScaleHeight - picHScroll.Height, .ScaleWidth - IIf(NeedVScrollbar, picVScroll.Width, 0), picHScroll.Height
        End If
        picCanvas.Move 0, 0, .ScaleWidth - IIf(NeedVScrollbar, picVScroll.Width, 0), .ScaleHeight - IIf(NeedHScrollbar, picHScroll.Height, 0)
    End With
    
    mViewport.Capacity = picCanvas.ScaleHeight / mNodeHeight
    
    picVScroll.Visible = NeedVScrollbar: picHScroll.Visible = NeedHScrollbar
    
    With mHScroll
        If NeedHScrollbar Then
            .Max = mMaxNodeWidth - picCanvas.ScaleWidth
            NewLargeChange = picCanvas.ScaleWidth
            If Not (.LargeChange = NewLargeChange) Then .LargeChange = NewLargeChange
        Else
            .Max = 1
            .LargeChange = 1
        End If
    End With
    
    mVScroll.SetParams IIf(mViewport.VisibleItemCount > 0, mViewport.Position, 1), 1, mViewport.MaxPosition, 1, mViewport.Capacity
    
   If RenderCC.Surface.Width <> picCanvas.ScaleWidth Or RenderCC.Surface.Height <> picCanvas.ScaleHeight Then
      Set RenderCC = Cairo.CreateSurface(picCanvas.ScaleWidth, picCanvas.ScaleHeight).CreateContext
   End If
    
End Sub
Private Sub CalcMetrics()

   mNodeHeight = mCaptionHeight
   If mNodeHeight < 20 Then
      mNodeHeight = 20
      mCaptionOffsetY = (mNodeHeight - mCaptionHeight) / 2
   Else
      mCaptionOffsetY = 0
   End If

   mIconSize = mNodeHeight - 4 'hence minimum icon size is 16
   mIconOffsetY = 2
End Sub
Private Function NodeCaptionStartX(pNodeTier As Integer) As Double
    NodeCaptionStartX = ((pNodeTier - 1) * mIconSize) + ((mIconSize * 2) + 4)
End Function
Private Sub CalcCaptionWidths(Optional pNodeKey As String = vbNullString)
Dim thisNode As cVhNode, RecalcAll As Boolean, FontHeight As Double
    
    'Debug.Print "Calc Caption Widths " & pNodeKey
    
    RecalcAll = (Len(pNodeKey) = 0)
    
    If RecalcAll Then
        mCaptionHeight = 0
        For Each thisNode In mAllNodes.Nodes
            RenderCC.SelectFont mAppearance.FontName, mAppearance.FontSize, , thisNode.NodeType.CaptionBold, thisNode.NodeType.CaptionItalic
            thisNode.CaptionWidth = 4 + RenderCC.GetTextExtents(thisNode.Caption, FontHeight)
            If FontHeight > mCaptionHeight Then mCaptionHeight = FontHeight
        Next thisNode
    Else
        Set thisNode = mAllNodes(pNodeKey)
        RenderCC.SelectFont mAppearance.FontName, mAppearance.FontSize, , thisNode.NodeType.CaptionBold, thisNode.NodeType.CaptionItalic
        thisNode.CaptionWidth = 4 + RenderCC.GetTextExtents(thisNode.Caption, FontHeight)
        If FontHeight > mCaptionHeight Then mCaptionHeight = FontHeight
    End If
    
    CalcMetrics
    mExposedNodes.NodeIndentation = mIconSize
    mExposedNodes.CalcMaxNodeWidth
    
    InitClientArea

End Sub
Public Sub ForceIntoView(pNodeKey As String)
    mAllNodes.SelectNode pNodeKey
    mAllNodes(pNodeKey).EnsureVisible
    mViewport.EnsureVisible pNodeKey
End Sub
Public Sub DragHandler(Source As Control, X As Single, Y As Single, State As Integer)
Dim PreviousDragOverIndex As Integer, DragOverNode As cVhNode, TargetIsValid As Boolean
    
   With mDragOp
      .IsInternal = ObjPtr(Source) = ObjPtr(UserControl.Extender)
      PreviousDragOverIndex = .DragOverIndex
      If Not State = vbLeave Then
         .DragOverIndex = HitTest(X, Y)
         .MouseXY.X = X
         .MouseXY.Y = Y
      Else
         .DragOverIndex = 0
      End If
   
      If .DragOverIndex > 0 Then
         Set DragOverNode = Nodes(mViewport.KeyFromViewportIndex(.DragOverIndex))
         .TargetNodeKey = DragOverNode.Key
      Else
         .TargetNodeKey = vbNullString
      End If
   
   End With
   
   If State = vbOver Then
      cDragTimer.Enabled = True
      If mDragOp.DragOverIndex <> PreviousDragOverIndex Then
         If (mDragOp.DragOverIndex > 0) Then
            TargetIsValid = IsValidDropTarget(DragOverNode)
            If (Not DragOverNode.Expanded) And DragOverNode.Children.Count > 0 Then
               mDragOp.HoverZoom = 0
               cDragTimer.Interval = mDragOp.ExpandHoverTime
            Else
               mDragOp.HoverZoom = -1
            End If
         Else
            TargetIsValid = False
            mDragOp.HoverZoom = -1
         End If
      Else
         TargetIsValid = IsValidDropTarget(DragOverNode)
      End If
   Else
      If State = vbLeave Then
         If mDragOp.IsInternal Then
            TargetIsValid = IsValidDropTarget(DragOverNode, True)
         Else
            'Set Source.DragIcon = mDragOp.ExternalIcon 'ADVICE NEEDED: This causes a crash. Below line doesn't!
            Set Source.DragIcon = IconToPicture(Cairo.CreateIconFromSurface(Cairo.ImageList("DragIcon"))) 'restore the source's DragIcon
         End If
      Else 'vbEnter
         TargetIsValid = IsValidDropTarget(DragOverNode)
         'Set Source.DragIcon = Form1.Icon
         Set mDragOp.ExternalIcon = Source.DragIcon 'cache the source's DragIcon
         InitDragIcons Source
      End If
      mDragOp.DragOverIndex = 0
      mDragOp.TargetNodeKey = vbNullString
      mDragOp.HoverZoom = -1
      cDragTimer.Enabled = False
   End If
    
   If mDragOp.IsInternal Then
      CreateDragIcon TargetIsValid, UserControl.Extender
   Else
      CreateDragIcon TargetIsValid, Source
      RaiseEvent ExternalDragOver(Source, X, Y, mDragOp.TargetNodeKey, State)
   End If

   Refresh

End Sub
Private Function IsValidDropTarget(Optional DragOverNode As cVhNode, Optional MouseLeftControl As Boolean) As Boolean
   If DragOverNode Is Nothing Then
      If MouseLeftControl Then
         IsValidDropTarget = mDragOp.SourceNode.IsValidExternalDragSource
      Else
         IsValidDropTarget = False
      End If
   Else
      If mDragOp.IsInternal Then
         IsValidDropTarget = mDragOp.SourceNode.IsValidInternalDragSource And _
                              DragOverNode.IsValidInternalDropTarget And _
                              DragOverNode.NodeType.IsValidChildType(mDragOp.SourceNode.NodeType) And _
                              Not DragOverNode.IsDescendentOf(mDragOp.SourceNode.Key)
      Else
         IsValidDropTarget = DragOverNode.IsValidExternalDropTarget
      End If
   End If
End Function
Private Sub InitDragIcons(Source As Control)
   If mDragOp.IsInternal Then
      Cairo.ImageList.AddSurface "DragIcon", Cairo.ImageList(mDragOp.SourceNode.NodeType.ImageKey).CreateSimilar(, , , True)
   Else
      Cairo.ImageList.AddSurface "DragIcon", Cairo.CreateSurfaceFromIconHandle(Source.DragIcon, True)
   End If
   
   With Cairo.ImageList("DragIcon").CreateSimilar(, , , True).CreateContext
      .RenderSurfaceContent "NO_DROP", 16, 16, 16, 16
      Cairo.ImageList.AddSurface "InvalidDropTarget", .Surface
   End With
   CreateDragIcon True, Source, True
End Sub
Private Function CreateDragIcon(ValidTarget As Boolean, Source As Control, Optional ForceChange As Boolean)
Dim thisImageKey As String

   If ValidTarget Then thisImageKey = "DragIcon" Else thisImageKey = "InvalidDropTarget"
   If mDragOp.PrevousIconKey <> thisImageKey Or ForceChange Then
      Set Source.DragIcon = IconToPicture(Cairo.CreateIconFromSurface(Cairo.ImageList(thisImageKey)))
      mDragOp.PrevousIconKey = thisImageKey
      Debug.Print "Icon Changed to "; thisImageKey
   End If

End Function
Public Sub DropHandler(Source As Control, X As Single, Y As Single)
Dim DropIndex As Long, DropNodeBehaviour As enumDragScope, DraggedNodeBehaviour As enumDragScope

On Error GoTo ErrHandler

   mDragOp.DragOverIndex = 0
   DropIndex = HitTest(X, Y)
   cDragTimer.Enabled = False
   
   If Not mDragOp.IsInternal Then Set Source.DragIcon = IconToPicture(Cairo.CreateIconFromSurface(Cairo.ImageList("DragIcon")))  'restore the source's drag icon
   
   If DropIndex > 0 Then
      mDragOp.TargetNodeKey = mViewport.KeyFromViewportIndex(DropIndex)
      DropNodeBehaviour = Nodes(mDragOp.TargetNodeKey).DragDropBehaviour
      If (DropNodeBehaviour And eInternalTarget) Or (DropNodeBehaviour And eExternalTarget) Then
         If mDragOp.IsInternal Then
            DraggedNodeBehaviour = mDragOp.SourceNode.DragDropBehaviour
            If (DraggedNodeBehaviour And eInternalSource) Then
               SelectedItem.SetParent Nodes(mDragOp.TargetNodeKey)
            End If
         Else
            If DropNodeBehaviour And eExternalTarget Then
               RaiseEvent ExternalDragDrop(Source, X, Y, mDragOp.TargetNodeKey)
            End If
         End If
      End If
      Refresh
   End If
   
   Exit Sub
   
ErrHandler:
   MsgBox Err.Description, vbExclamation, "Illegal Drop Target"
End Sub
Public Property Get NodeTypes() As cNodeTypes
   Set NodeTypes = Nodes.NodeTypes
End Property
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

   If Not Ambient.UserMode Then Exit Sub
   
   Set mHandPointer = CreateCursor
   
   Set mVScroll = New cScrollbar
   mVScroll.Init picVScroll, True, 1, 1, 1, 1
   Set mHScroll = New cScrollbar
   mHScroll.Init picHScroll, False, 1, 1, 1, 1
   
   Set mViewport = New cTreeViewport
   Set mAllNodes = mViewport.AllNodes
   mAllNodes.Suspended = True
   Set mExposedNodes = mViewport.ExposedNodes
   Set mAppearance = New cTreeAppearance
   
   mNodeHeight = 16
   mDragOp.ExpandHoverTime = 1000
   
   Set RenderCC = Cairo.CreateSurface(10, 10).CreateContext
   Set mBackgroundSrf = Cairo.CreateSurface(10, 10)
   Set cDragTimer = New_c.Timer(200)
   Cairo.FontOptions = CAIRO_ANTIALIAS_DEFAULT
   
   If SCMouseTrack Is Nothing Then
      Set SCMouseTrack = New_c.SubClass
      SCMouseTrack.Hook picCanvas.hWnd
   End If
End Sub
Private Sub UserControl_Terminate()
   On Error Resume Next
   If Not SCMouseTrack Is Nothing Then
      SCMouseTrack.UnHook
      Set SCMouseTrack = Nothing
   End If
   Set mVScroll = Nothing
   Set mHScroll = Nothing
   Set cDragTimer = Nothing
   Set mViewport = Nothing
   Set mAllNodes = Nothing
   Set mExposedNodes = Nothing
   Set mAppearance = Nothing
   Set mDragOp.SourceNode = Nothing
End Sub
